#! /usr/bin/env python
"""
This program monitors WeatherCat and relaunches it if it doesn't find it

Uses command line tools:
	ps

"""

import time
import os
import re
import sys
#import findertools

#check_interval_in_secs = 5 * 60			# every 5 minutes (give time for system to settle down)
check_interval_in_secs = 30

def reboot(program_path, program_name):
	""" Function to do the actual rebooting """

	use_finder = False
	quit_after_launch = True

	# launch WeatherCat	
	print "reboot_weathercat - rebooted program %s on %s" % (program_name, time.strftime("%a, %d %b %Y %H:%M:%S +0000", time.gmtime()))
	
#	if not use_finder:
	if not quit_after_launch:
		# we choose spawn here	
		process_id = os.spawnl(os.P_NOWAIT, program_path, program_path)		# execute and keep running
	else:
		os.execl(program_path, program_path)								# execute and terminate
#	else:
#		# we could also tell the finder to launch it?
#		findertools.launch(program_path)
#		if quit_after_launch:
#			sys.exit(0)

	# currently we don't re-instate the process serial number (-psn)
	# also currently this is a child process...	
	# note on full path ps there is a -psn_xxxx after pathname of command (which includes spaces) if launched from the finder...


def monitor_program(program_path):
	""" This function does the actual monitoring of a process and re-launches if necessary """

	program_base_path, program_name = os.path.split(program_path)
	
	while True:
		time.sleep(check_interval_in_secs)
		put, get = os.popen4("ps -wwcx")		# Executes cmd as a sub-process. Returns the file objects (child_stdin, child_stdout)
								# ps options
								#
								#	ww full width
								#	a other users
								#	u status information
								#	x processes without controlling terminals
								#   c no full paths
								
		for line in get.readlines():
			if re.search(program_name,line): 
				#print line,
				break;
		else:		# if we finish the loop without finding the entry
			reboot(program_path, program_name)	# reboot if not in the process list

		# print "reboot_weathercat - tick"

	# maybe print to private file as well.
	# take account of whether it was hidden ??? 
	# watchdog - delete a file that has been created???


def main():
	""" this program watches the processes and relaunches a specific process if it disappears"""

	# command line args ....
	#   program (full path) to launch

	command_line = sys.argv[1:]

	num_options = len(command_line)	

	# perhaps we should not launch if there is a version of reboot_wc already monitoring this specific application on this user?
	
	if num_options == 1:
		monitor_program(command_line[0])
	else:
		print "reboot_weathercat - need to supply single path to an applications to monitor"


# *******************
# run our application
# *******************

if __name__ == "__main__":
    main()
