#!/usr/bin/env python

# (C) Trixology 2012
# Based on:
# http://docs.python.org/library/email-examples.html#email-examples
#
# NOTE: if smtp username is "" then code will not use the smtp authentication method or tls
#
# input parameters
#	sys.argv[1] is the sender email address
#	sys.argv[2] is the reciever email address,
#		this can be a comma separated string for multiple recievers
#	sys.argv[3] is the subject text
#	sys.argv[4] is the body text
#	sys.argv[5] is the smtp host
#	sys.argv[6] is the smtp username
#	sys.argv[7] is the smtp password
#	sys.argv[8] is the smtp port
#	sys.argv[9] is use tls
#	sys.argv[10] path to attachment TO SEND

#

import smtplib, email, sys, time
import mimetypes
import os
# For guessing MIME type based on file name extension
import mimetypes

from optparse import OptionParser

from email import encoders
from email.message import Message
from email.mime.audio import MIMEAudio
from email.mime.base import MIMEBase
from email.mime.image import MIMEImage
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText

COMMASPACE = ', '

# check to make sure the number of arguments is correct
if len(sys.argv) != 11:
  print 'Usage: send_email.py <sender> <receiver> <subject> <bodyText> <smptHost> <username> <password> <port> <tls> <path to attachment>'
  sys.exit(1)

# get the argv variables
sender = sys.argv[1]
receiver = sys.argv[2]
subj = sys.argv[3]
bodyText = sys.argv[4]
smtpHost = sys.argv[5]
username = sys.argv[6] # use "" if no SMTP authentication is required
passwd = sys.argv[7] # ignored if no SMTP authentication is required
port = sys.argv[8] # ignored if no SMTP authentication is required
tls =  sys.argv[9] # ignored if no auth required
attach_path = sys.argv[10]; 
# create a list from the receiver in case we have a comma separated string of multiple receivers
rList = []
rList = receiver.split(',');

part1 = MIMEText(bodyText, 'plain')

	
directory = attach_path
if not directory:
    directory = '.'
# Create the enclosing (outer) message
outer = MIMEMultipart()
outer['Subject'] = subj
outer['To'] = receiver #COMMASPACE.join(receiver)
outer['From'] = sender
outer.preamble = 'This is a mulitipart message - please use a MIME-aware mail reader to see all the content.\n'
outer.attach(part1)

#for filename in os.listdir(directory):
#    path = os.path.join(directory, filename)
path=attach_path

if path!="":

    if not os.path.isfile(path):
	print 'failed: ', '(Attachment error or not found)'
	sys.exit(1)
	
    # Guess the content type based on the file's extension.  Encoding
    # will be ignored, although we should check for simple things like
    # gzip'd or compressed files.
    ctype, encoding = mimetypes.guess_type(path)
    if ctype is None or encoding is not None:
	# No guess could be made, or the file is encoded (compressed), so
	# use a generic bag-of-bits type.
	ctype = 'application/octet-stream'
    maintype, subtype = ctype.split('/', 1)
    if maintype == 'text':
	fp = open(path)
	# Note: we should handle calculating the charset
	msg = MIMEText(fp.read(), _subtype=subtype)
	fp.close()
    elif maintype == 'image':
	fp = open(path, 'rb')
	msg = MIMEImage(fp.read(), _subtype=subtype)
	fp.close()
    elif maintype == 'audio':
	fp = open(path, 'rb')
	msg = MIMEAudio(fp.read(), _subtype=subtype)
	fp.close()
    else:
	fp = open(path, 'rb')
	msg = MIMEBase(maintype, subtype)
	msg.set_payload(fp.read())
	fp.close()
	# Encode the payload using Base64
	encoders.encode_base64(msg)
    # Set the filename parameter
    msg.add_header('Content-Disposition', 'attachment', filename=path)
    outer.attach(msg)

# Now send the message
composed = outer.as_string()

# determine if a passworded smpt host is being used and connect as necessary
if username == "":
	server = smtplib.SMTP(smtpHost) # smtp server is not password protected
else:
	server = smtplib.SMTP(smtpHost, port)
	if tls == "1":
	    server.ehlo()
	    server.starttls()
	    server.ehlo()
	server.login(username, passwd)

failed = server.sendmail(sender, rList, composed)
server.quit() 

# return the status
if failed:
  print 'failed: ', failed
